package es.verdnatura.domain

import es.verdnatura.presentation.common.itemBarCodeSalix
import es.verdnatura.presentation.common.itemPackingTypeSalix
import es.verdnatura.presentation.view.feature.ajustes.model.SectorItemVO
import es.verdnatura.presentation.view.feature.articulo.model.ItemPackingType
import es.verdnatura.presentation.view.feature.collection.SalixSaleQuantity
import es.verdnatura.presentation.view.feature.collection.listSaleSalix
import es.verdnatura.presentation.view.feature.historicoshelvinglog.model.ShelvingLogSalix
import es.verdnatura.presentation.view.feature.login.model.LoginSalixVO
import es.verdnatura.presentation.view.feature.login.model.SalixGrupo
import es.verdnatura.presentation.view.feature.packaging.model.EntrySalix
import es.verdnatura.presentation.view.feature.packaging.model.ItemSupplier
import es.verdnatura.presentation.view.feature.packaging.model.Supplier
import es.verdnatura.presentation.view.feature.sacador.model.CollectionVO
import es.verdnatura.presentation.view.feature.workermistake.model.DepartmentMistake
import okhttp3.MultipartBody
import retrofit2.Call
import retrofit2.http.*

interface SalixService {

    @POST("Accounts/login")
    fun login(
        @Body params: LoginSalixVO
    ):
            Call<LoginSalixVO>

    /*  @POST("chats/sendCheckingPresence")
      fun sendChekingPresence(
          @Body params: SalixMessageVO
      ):
              Call<Boolean>

      @POST("chats/send")
      fun sendGroup(
          @Body params: SalixGrupo
      ):
              Call<Boolean>*/

    @GET("collections/getSectors")
    fun getSectorsSalix(
    ):
            Call<List<SectorItemVO>>

    @GET("collections/getCollection")
    fun getCollectionSalix(
    ):
            Call<List<CollectionVO>>


    @GET("collections/sectorCollection_get")
    fun sectorCollection_get(
    ):
            Call<List<CollectionVO>>

    @POST("collections/setSaleQuantity")
    fun collectionIncreaseQuantitySalix(
        @Body params: SalixSaleQuantity
    ):
            Call<Any>

    @Multipart
    @POST("Entries/{id}/uploadFile")
    fun uploadEntryPhoto(
        @Path("id") id: Number,
        @Query("warehouseId") warehouseId: Number,
        @Query("companyId") companyId: Number,
        @Query("dmsTypeId") dmsTypeId: Number,
        @Query("reference") reference: String,
        @Query("description") description: String,
        @Query("hasFile") hasFile: Boolean,
        @Part file: MultipartBody.Part,
    ):
            Call<Any>

    @POST("Entries/{id}/addFromBuy")
    fun addFromBuy(
        @Path("id") id: Number,
        @Query("item") item: Number,
        @Query("printedStickers") printedStickers: Number
    ):
            Call<Any>


    @POST("tickets/{idTicket}/transferSales") //-->saleMove en Silex
    fun transferSalesSalix(
        @Path("idTicket") idTicket: String,
        @Body params: listSaleSalix
    ):
            Call<Any>


    //https://test-salix.verdnatura.es/api/Departments?filter={"fields": {"id": true, "name": true},"where": {"name": "COMPRAS"}}
    // http://test-salix.verdnatura.es/api/Departments?filter={"fields": {"id": true, "name": true},"where": {"hasToMistake": "FALSE"}}

    //  @GET("api/Departments?filter={\"fields\": {\"id\": true, \"name\": true},\"where\": {\"hasToMistake\": \"FALSE\"}}")
    @GET("Departments")
    fun department_getHasMistake(
        @Query("filter") filter: String = "{\"fields\": {\"id\": true, \"name\": true},\"where\": {\"name\": \"INFORMATICA\"}}"
        // @Query("name") name:String ="COMPRAS"
    ):
            Call<List<DepartmentMistake>>

    @GET("Workers/{idWorker}/sip")
    fun sip_getExtension(
        @Path("idWorker") idWorker: Int,
    ):
            Call<Any>

    @PATCH("Items/{itemFk}")
    fun update_ItemPackingType(
        @Path("itemFk") itemFk: String,
        @Body params: itemPackingTypeSalix
    ):
            Call<Any>


    @GET("ItemPackingTypes")
    fun get_ItemPackingType(

    ):
            Call<List<ItemPackingType>>


    @PUT("ItemBarCodes")//REVISADA
    fun barcodes_edit(
        @Body params: itemBarCodeSalix
    ):
            Call<Any>


    @GET("ItemBarCodes/{barCodeValue}/toItem")//REVISADA
    fun barcodes_toitem(
        @Path("barCodeValue") barCodeValue: String
    ):
            Call<String>

    @GET("Suppliers")//REVISADA
    fun getSuppliers(
        //@Body params:JSONObject=JSONObject("""filter"={"fields":{"id":true,"name":true},"include":[{"relation":"contacts","scope":{"fields":["email"],"order":"id DESC","limit":1,"where":{"email":{"neq":null}}}}]}""")
        /* @Query("filter") filter:String="{\"fields\":{\"id\":true,\"name\":true},\"include\":[{\"relation\":\"contacts\"," +
                 "\"scope\":{" +
                 "\"fields\":[\"email\"],\"order\":\"id DESC\",\"limit\":1," +
                 "\"where\":{ \"email\":{\"neq\":null } }}}]})"*/

    ):
            Call<List<Supplier>>

    @PUT("Entries")//REVISADA
    fun Entries(
        @Body entry: EntrySalix
    ):
            Call<EntrySalix>

    @GET("Shelvings")
    fun Shelvings(
        @Query("filter") filter: String
    ):
            Call<List<ShelvingLogSalix>>

    @GET("Suppliers/{supplierId}/getItemsPackaging")
    fun getItemsPackaging(
        @Path("supplierId") supplierId: Int,
        @Query("entry") entry: Int

    ):
            Call<List<ItemSupplier>>

    @POST("Entries/addFromPackaging")
    fun addFromPackaging(
        @Query("supplier") supplier: Int,
        @Query("isTravelReception") isTravelReception: Boolean

    ):
            Call<EntrySalix>

    @POST("Images/upload")
    @Multipart
    fun uploadImage(
        @Query ("collection") collection: String,
        @Query("id") id: Int,
        @Part filePart: MultipartBody.Part,
    ):
            Call<Any>

}


interface SalixServiceSend {

    @POST("chats/send")
    fun sendGroup(
        @Body params: SalixGrupo
    ):
            Call<Boolean>
}