package es.verdnatura.presentation.view.feature.delivery.model

import androidx.room.Entity
import androidx.room.PrimaryKey
import java.text.SimpleDateFormat

class FreeLanceDeliveryInfoList(
    var list: List<DeliveryInfo> = listOf()
)

class CompanyInfoList(
    var list: List<DeliveryInfo> = listOf()
)

class DeliveryInfo(
    var name: String = "",
    var street: String = "",
    var city: String = "",
    var nif: String = "",
    var postCode: Int = 0
)

class ExpeditionInfoList(
    var list: List<ExpeditionInfoLog> = listOf()
)

class ExpeditionInfoLog(
    var description: String = "",
    var name: String = "",
    var created: String,
) {
    /* posiblidad de meter función directo en xml*/
    fun getDateString(): String {
        val format = SimpleDateFormat("dd/MM/yyy")
        // return format.format(created)
        return created
    }
}

class RouteDeliveryList(
    var list: List<RouteDelivery> = listOf()
)

class RouteDelivery(
    var id: Int,
    var created: String,
    var name: String

)

class
Expedition(
    var id: Int
)

class ExpeditionList(
    var list: List<ExpeditionInfoLoadUnload> = listOf(),
)

@Entity(tableName = "expedition")
class ExpeditionInfoLoadUnload(
    @PrimaryKey var id: Int,
    var ticketFk: Int,
    var routeFk: Int,
    var addressFk: Int,
    var itemPackingTypeConcat: String?,
    var city: String,
    var street: String,
    var code: String?,
    var nickname: String,
    var postalCode: Int,
    var isError: Boolean = false
)

@Entity(tableName = "expeditionPending")
class ExpeditionInfoPending(
    @PrimaryKey var id: Int,
    var ticketFk: Int,
    var routeFk: Int,
    var addressFk: Int,
    var itemPackingTypeConcat: String?,
    var city: String,
    var street: String,
    var code: String?,
    var nickname: String,
    var postalCode: Int
)


class ExpeditionSummaryList(
    var list: List<ExpeditionInfoSummary> = listOf()
)

class ExpeditionInfoSummary(
    var routeFk: Int,
    var addressFk: Int,
    var itemPackingType: String?,
    var total: Int,
    var delivery: Int = 0,
    var lost: Int = 0,
    var delivered: Int = 0
)

