package es.verdnatura.presentation.view.feature.paletizador.fragment

import android.view.View
import android.view.inputmethod.EditorInfo
import es.verdnatura.R
import es.verdnatura.databinding.FragmentExpeditionscanSorterBinding
import es.verdnatura.presentation.base.BaseFragment
import es.verdnatura.presentation.common.itemScanned
import es.verdnatura.presentation.view.component.CustomDialogInputTwoValues
import org.json.JSONObject

class CmrExpeditionPalletFragment(
    var title: String = ""
) : BaseFragment<FragmentExpeditionscanSorterBinding, CmrExpeditionPalletViewModel>(
    CmrExpeditionPalletViewModel::class
) {

    override fun getLayoutId(): Int = R.layout.fragment_expeditionscan_sorter
    private lateinit var customDialogList: CustomDialogInputTwoValues
    private var itemScaned: String = ""
    private var dataScanned: itemScanned? = null
    private var dataScannedTwo: itemScanned? = null

    companion object {
        fun newInstance(title: String) = CmrExpeditionPalletFragment(title)
    }

    override fun init() {

        customDialogList = CustomDialogInputTwoValues(requireContext())
        ma.hideBottomNavigation(View.GONE)
        binding.splashProgress.visibility = View.GONE
        setEvents()
        setToolBar()
        showExpeditionPalletScan()
        super.init()
    }

    private fun setToolBar() {
        binding.mainToolbar.toolbarTitle.text = title
    }

    private fun cmrExpeditionPallet_add(vExpeditionPallet: Int?, vCmrId: Int?) {

        customDialogList.dismiss()
        binding.splashProgress.visibility = View.VISIBLE
        viewModel.cmrExpeditionPallet_add(
            vExpeditionPallet!!,
            vCmrId!!
        )

    }

    private fun setEvents() {

        binding.mainToolbar.backButton.setOnClickListener {
            requireActivity().onBackPressed()

        }

    }

    override fun observeViewModel() {

        with(viewModel) {
            binding.splashProgress.visibility = View.GONE
            responsescan.observe(viewLifecycleOwner) {

                if (it.isError) {

                    ma.messageWithSound(
                        getString(R.string.cmrError) + it.errorMessage,
                        isError = true,
                        isPlayed = true,
                        isToasted = true
                    )
                    showExpeditionPalletScan()

                } else {
                    binding.splashProgress.visibility = View.GONE
                    ma.messageWithSound(
                        getString(R.string.operationSuccess),
                        isError = false,
                        isPlayed = true
                    )
                    showExpeditionPalletScan()

                }
            }

        }

    }

    private fun showExpeditionPalletScan() {
        customDialogList.setHint(true)
        customDialogList.setValue("")
        customDialogList.setValueTwo("")
        customDialogList.setInfoTex(getString(R.string.codeQrORPallet))
        customDialogList.setInfoTextTwo(getString(R.string.codeQrOrCMR))
        customDialogList.setTitle(getString(R.string.scanValues))
        customDialogList.setHint(false)

        customDialogList.setOkButton(getString(R.string.end)) {
            ma.hideKeyboard(customDialogList.getEditText())
            customDialogList.dismiss()
            binding.mainToolbar.backButton.performClick()
        }.setValue("").show()

        customDialogList.setFocusText()
        ma.hideKeyboard(customDialogList.getEditText())
        customDialogList.getEditText().setOnEditorActionListener { _, actionId, _ ->
            if (actionId == EditorInfo.IME_ACTION_SEARCH || actionId == EditorInfo.IME_ACTION_DONE || actionId == 0 || actionId == 5 || actionId == 6) {
                // var action = true
                if (customDialogList.getValue().isNotEmpty()) {
                    dataScanned = itemScan(customDialogList.getValue())

                    if (dataScanned == null) {
                        // action = false
                        /*ma.messageWithSound(
                            getString(R.string.errorPalletCmrNotScanned),
                            isError = true,
                            isPlayed = true,
                            titleWithError = getString(R.string.warning),
                            isToasted = true
                        )
                        customDialogList.setValue("")*/

                    } else {
                        // action = false
                        customDialogList.setValue(dataScanned!!.id.toString())
                        customDialogList.setHint(true)
                        if (dataScanned!!.table == "cmr") {
                            customDialogList.setInfoTextTwo(getString(R.string.scanLabelPallet))
                        } else {
                            customDialogList.setInfoTextTwo(getString(R.string.scanLabelCMR))
                        }
                        customDialogList.setHint(false)
                    }
                }

                return@setOnEditorActionListener false

            }
            false

        }
        customDialogList.getEditTextTwo().setOnEditorActionListener { _, actionId, _ ->
            if (actionId == EditorInfo.IME_ACTION_SEARCH || actionId == EditorInfo.IME_ACTION_DONE || actionId == 0 || actionId == 5 || actionId == 6) {

                if (customDialogList.getValueTwo().isNotEmpty() && customDialogList.getValue()
                        .isNotEmpty()
                ) {
                    dataScannedTwo = itemScan(customDialogList.getValueTwo())
                    if (dataScannedTwo == null) {
                        cmrExpeditionPallet_add(
                            customDialogList.getValue().toInt(),
                            customDialogList.getValueTwo().toInt()
                        )

                        /* var messageLabel = ""
                         when (dataScanned!!.table) {
                             "cmr" -> {
                                 messageLabel = "CMR"
                             }
                             "expeditionPallet" -> {
                                 messageLabel = "Pallet"
                             }
                         }

                         ma.messageWithSound(
                             String.format(
                                 getString(R.string.labelPalletOrCmrNotValid),
                                 messageLabel
                             ),
                             isError = true,
                             isPlayed = true,
                             titleWithError = getString(R.string.warning),
                             isToasted = true
                         )
                         customDialogList.setValueTwo("")*/

                    } else {
                        if (dataScanned != null) {


                            if (dataScanned!!.table == dataScannedTwo!!.table) {
                                ma.messageWithSound(
                                    getString(R.string.errorSameType),
                                    isError = true,
                                    isPlayed = true,
                                    titleWithError = "Aviso",
                                    isToasted = true
                                )
                                customDialogList.setValueTwo("")
                            } else {
                                customDialogList.setValueTwo(dataScanned!!.id.toString())
                                cmrExpeditionPallet_add(
                                    if (dataScannedTwo!!.table == "cmr") {
                                        dataScanned!!.id
                                    } else {
                                        dataScannedTwo!!.id
                                    },
                                    if (dataScannedTwo!!.table == "cmr") {
                                        dataScannedTwo!!.id
                                    } else {
                                        dataScanned!!.id
                                    }
                                )
                            }
                        } else {
                            cmrExpeditionPallet_add(
                                customDialogList.getValue().toInt(),
                                dataScannedTwo!!.id

                            )
                        }
                    }
                }
            }

            return@setOnEditorActionListener true
        }

    }

}

private fun itemScan(value: String): itemScanned? {

    return try {
        val valueScanned = itemScanned(JSONObject(value))

        if (valueScanned.table == "cmr" || valueScanned.table == "expeditionPallet") {
            valueScanned
        } else {
            null
        }

    } catch (Ex: Exception) {
        return null
    }


}
